#===============================================================================
# Config Start
#===============================================================================

ragequit_max_delay = 10.0 # Amount of seconds between death and disconnect.

#===============================================================================
# Config End
#===============================================================================

import es
import gamethread

class RageQueue(list):
    def append(self, item):
        if list.__contains__(self, item):
            gamethread.cancelDelayed('ragequit_%s' % item)
        else:
            list.append(self, item)
        gamethread.delayedname(ragequit_max_delay,
                               'ragequit_%s' % item,
                               self.remove,
                               (item,))
rage_queue = RageQueue()

names = {}

def load():
    downloadables()
    
def es_map_start(ev):
    downloadables()
    
def downloadables():
    es.stringtable('downloadables', 'sound/ragequit/ragequit.mp3')

def player_connect(ev):
    names[ev['userid']] = ev['name']
    
def player_changename(ev):
    names[ev['userid']] = ev['newname']

def player_death(ev):
    rage_queue.append(ev['userid'])
    
def player_disconnect(ev):
    if ev['userid'] in rage_queue and ev['reason'].lower() == 'disconnect by user':
        rage_queue.remove(ev['userid'])
        ragequit(names[ev['userid']])
        
def ragequit(name):
    es.msg('#multi', '#lightgreen%s#default has left in #ligthgreenrage!' % name)
    es.emitsound('entity', 0, 'ragequit/ragequit.mp3', 1.0, 0.0)
